namespace RadishField
{
    public class Cell
    {
        private static readonly int[][] offsetTable =
            {
                new[] {-1, -1}, new[] {0, -1}, new[] {1, -1},
                new[] {-1, 0},                 new[] {1, 0},
                new[] {-1, 1},  new[] {0, 1},  new[] {1, 1},
            };

        private readonly int x;
        private readonly int y;
        private readonly int numOfRadish;
        private readonly Field field;
       
        public Cell(int x, int y, int numOfRadish, Field field)
        {
            this.x = x;
            this.y = y;
            this.numOfRadish = numOfRadish;
            this.field = field;
        }

        public int NumOfRadish
        {
            get { return numOfRadish; }
        }

        public int GetSpecialNum()
        {
            int specialNum = 0;
            foreach (int[] offset in offsetTable)
            {
                Cell cell = field.GetCell(offset[0] + x, offset[1] + y);
                if (cell != null)
                {
                    specialNum += cell.NumOfRadish;
                }
            }
            return specialNum;
        }
    }
}