using System.Collections;
using System.Collections.Generic;

namespace RadishField
{
    public class Field : IEnumerable<Cell>
    {
        private readonly int width;
        private readonly int height;
        private readonly Cell[,] field;

        public Field(int width, int height)
        {
            this.width = width;
            this.height = height;
            field = new Cell[width,height];
        }

        public void AddCell(int x, int y, int numOfRadish)
        {
            field[x, y] = new Cell(x, y, numOfRadish, this);
        }

        public Cell GetCell(int x, int y)
        {
            if (x >= 0 && x < width && y >= 0 && y < height)
            {
                return field[x, y];
            }
            return null;
        }

        public IEnumerator<Cell> GetEnumerator()
        {
            foreach (Cell cell in field)
            {
                yield return cell;
            }
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }
}