﻿using System;
using System.Linq;

namespace RadishField
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            string[] testField = {
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890",
                                     "1234567890"
                                 };
            Console.WriteLine(CountSpecialNumbers(new[] {"111", "111", "111"}, 4, 8));
            Console.WriteLine(CountSpecialNumbers(new[] {"111", "141", "111"}, 4, 8));
            Console.WriteLine(CountSpecialNumbers(new[] {"2309", "0239", "2314"}, 5, 7));
            Console.WriteLine(CountSpecialNumbers(new[] {"924", "231", "390", "910", "121"}, 31, 36));
            Console.WriteLine(CountSpecialNumbers(new[] {"5"}, 3, 8));
            Console.WriteLine(CountSpecialNumbers(testField, 3, 18));
        }

        public static int CountSpecialNumbers(string[] input, int A, int B)
        {
            Field field = GetField(input);
            return field.Count(cell => cell.GetSpecialNum().Between(A, B));
        }

        private static Field GetField(string[] input)
        {
            Field field = new Field(input[0].Length, input.Length);
            for (int line = 0; line < input.Length; line++)
            {
                string strLine = input[line];
                for (int column = 0; column < strLine.Length; column++)
                {
                    int numOfRadish = strLine[column] - '0';
                    field.AddCell(column, line, numOfRadish);
                }
            }
            return field;
        }
    }
}